Index: palm/trunk/SOURCE/lpm_exchange_horiz.f90
===================================================================
--- palm/trunk/SOURCE/lpm_exchange_horiz.f90	(revision 1821)
+++ palm/trunk/SOURCE/lpm_exchange_horiz.f90	(revision 1822)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Tails removed. Unused variables removed.
 !
 ! Former revisions:
@@ -67,5 +67,5 @@
 ! Description:
 ! ------------
-!> Exchange of particles (and tails) between the subdomains.
+! Exchange of particles between the subdomains.
 !------------------------------------------------------------------------------!
  MODULE lpm_exchange_horiz_mod
@@ -93,14 +93,12 @@
 
     USE particle_attributes,                                                   &
-        ONLY:  alloc_factor, deleted_particles, deleted_tails, grid_particles, &
-               ibc_par_lr, ibc_par_ns, maximum_number_of_tails,                &
-               maximum_number_of_tailpoints, min_nr_particle,                  &
-               mpi_particle_type, number_of_tails, number_of_particles,        &
-               offset_ocean_nzt, particles,                                    &
-               particle_tail_coordinates, particle_type, prt_count,            &
-               tail_mask, trlp_count_sum,                                      &
+        ONLY:  alloc_factor, deleted_particles, grid_particles,                &
+               ibc_par_lr, ibc_par_ns, min_nr_particle,                        &
+               mpi_particle_type, number_of_particles,                         &
+               offset_ocean_nzt, offset_ocean_nzt_m1, particles,               &
+               particle_type, prt_count, trlp_count_sum,                       &
                trlp_count_recv_sum, trnp_count_sum, trnp_count_recv_sum,       &
                trrp_count_sum, trrp_count_recv_sum, trsp_count_sum,            &
-               trsp_count_recv_sum, use_particle_tails, zero_particle
+               trsp_count_recv_sum, zero_particle
 
     USE pegrid
@@ -156,9 +154,6 @@
     INTEGER(iwp) ::  j                                       !<
     INTEGER(iwp) ::  jp                                      !<
-    INTEGER(iwp) ::  k                                       !<
     INTEGER(iwp) ::  kp                                      !<
     INTEGER(iwp) ::  n                                       !<
-    INTEGER(iwp) ::  nn                                      !<
-    INTEGER(iwp) ::  tlength                                 !<
     INTEGER(iwp) ::  trlp_count                              !<
     INTEGER(iwp) ::  trlp_count_recv                         !<
@@ -178,9 +173,4 @@
     INTEGER(iwp) ::  trspt_count_recv                        !<
 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  trlpt        !<
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  trnpt        !<
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  trrpt        !<
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  trspt        !<
-
     TYPE(particle_type), DIMENSION(:), ALLOCATABLE ::  rvlp  !<
     TYPE(particle_type), DIMENSION(:), ALLOCATABLE ::  rvnp  !<
@@ -196,4 +186,15 @@
 #if defined( __parallel )
 
+!
+!-- Exchange between subdomains.
+!-- As soon as one particle has moved beyond the boundary of the domain, it
+!-- is included in the relevant transfer arrays and marked for subsequent
+!-- deletion on this PE.
+!-- First sweep for crossings in x direction. Find out first the number of
+!-- particles to be transferred and allocate temporary arrays needed to store
+!-- them.
+!-- For a one-dimensional decomposition along y, no transfer is necessary,
+!-- because the particle remains on the PE, but the particle coordinate has to
+!-- be adjusted.
     trlp_count  = 0
     trlpt_count = 0
@@ -226,8 +227,6 @@
                       IF ( i < nxl )  THEN
                          trlp_count = trlp_count + 1
-                         IF ( particles(n)%tail_id /= 0 )  trlpt_count = trlpt_count + 1
                       ELSEIF ( i > nxr )  THEN
                          trrp_count = trrp_count + 1
-                         IF ( particles(n)%tail_id /= 0 )  trrpt_count = trrpt_count + 1
                       ENDIF
                    ENDIF
@@ -247,10 +246,4 @@
        trlp = zero_particle
        trrp = zero_particle
-
-       IF ( use_particle_tails )  THEN
-          ALLOCATE( trlpt(maximum_number_of_tailpoints,5,trlpt_count), &
-                    trrpt(maximum_number_of_tailpoints,5,trrpt_count) )
-          tlength = maximum_number_of_tailpoints * 5
-       ENDIF
 
        trlp_count  = 0
@@ -269,6 +262,4 @@
              particles => grid_particles(kp,jp,ip)%particles(1:number_of_particles)
              DO  n = 1, number_of_particles
-
-                nn = particles(n)%tail_id
 !
 !--             Only those particles that have not been marked as 'deleted' may
@@ -292,9 +283,4 @@
                                particles(n)%origin_x = ( nx + 1 ) * dx + &
                                particles(n)%origin_x
-                               IF ( use_particle_tails  .AND.  nn /= 0 )  THEN
-                                  i  = particles(n)%tailpoints
-                                  particle_tail_coordinates(1:i,1,nn) = ( nx + 1 ) * dx &
-                                  + particle_tail_coordinates(1:i,1,nn)
-                               ENDIF
                             ELSE
                                trlp_count = trlp_count + 1
@@ -312,12 +298,4 @@
                                ENDIF
 
-                               IF ( use_particle_tails  .AND.  nn /= 0 )  THEN
-                                  trlpt_count = trlpt_count + 1
-                                  trlpt(:,:,trlpt_count) = particle_tail_coordinates(:,:,nn)
-                                  trlpt(:,1,trlpt_count) = ( nx + 1 ) * dx + &
-                                  trlpt(:,1,trlpt_count)
-                                  tail_mask(nn) = .FALSE.
-                                  deleted_tails = deleted_tails + 1
-                               ENDIF
                             ENDIF
 
@@ -327,8 +305,4 @@
                             particles(n)%particle_mask = .FALSE.
                             deleted_particles = deleted_particles + 1
-                            IF ( use_particle_tails  .AND.  nn /= 0 )  THEN
-                               tail_mask(nn) = .FALSE.
-                               deleted_tails = deleted_tails + 1
-                            ENDIF
 
                          ELSEIF ( ibc_par_lr == 2 )  THEN
@@ -348,10 +322,4 @@
                          deleted_particles = deleted_particles + 1
 
-                         IF ( use_particle_tails  .AND.  nn /= 0 )  THEN
-                            trlpt_count = trlpt_count + 1
-                            trlpt(:,:,trlpt_count) = particle_tail_coordinates(:,:,nn)
-                            tail_mask(nn) = .FALSE.
-                            deleted_tails = deleted_tails + 1
-                         ENDIF
                       ENDIF
 
@@ -367,9 +335,4 @@
                                particles(n)%origin_x = particles(n)%origin_x - &
                                ( nx + 1 ) * dx
-                               IF ( use_particle_tails  .AND.  nn /= 0 )  THEN
-                                  i = particles(n)%tailpoints
-                                  particle_tail_coordinates(1:i,1,nn) = - ( nx+1 ) * dx &
-                                  + particle_tail_coordinates(1:i,1,nn)
-                               ENDIF
                             ELSE
                                trrp_count = trrp_count + 1
@@ -381,12 +344,4 @@
                                deleted_particles = deleted_particles + 1
 
-                               IF ( use_particle_tails  .AND.  nn /= 0 )  THEN
-                                  trrpt_count = trrpt_count + 1
-                                  trrpt(:,:,trrpt_count) = particle_tail_coordinates(:,:,nn)
-                                  trrpt(:,1,trrpt_count) = trrpt(:,1,trrpt_count) - &
-                                  ( nx + 1 ) * dx
-                                  tail_mask(nn) = .FALSE.
-                                  deleted_tails = deleted_tails + 1
-                               ENDIF
                             ENDIF
 
@@ -396,8 +351,4 @@
                             particles(n)%particle_mask = .FALSE.
                             deleted_particles = deleted_particles + 1
-                            IF ( use_particle_tails  .AND.  nn /= 0 )  THEN
-                               tail_mask(nn) = .FALSE.
-                               deleted_tails = deleted_tails + 1
-                            ENDIF
 
                          ELSEIF ( ibc_par_lr == 2 )  THEN
@@ -417,10 +368,4 @@
                          deleted_particles = deleted_particles + 1
 
-                         IF ( use_particle_tails  .AND.  nn /= 0 )  THEN
-                            trrpt_count = trrpt_count + 1
-                            trrpt(:,:,trrpt_count) = particle_tail_coordinates(:,:,nn)
-                            tail_mask(nn) = .FALSE.
-                            deleted_tails = deleted_tails + 1
-                         ENDIF
                       ENDIF
 
@@ -452,40 +397,4 @@
        DEALLOCATE(rvrp)
 
-       IF ( use_particle_tails )  THEN
-
-          CALL MPI_SENDRECV( trlpt_count,      1, MPI_INTEGER, pleft,  0, &
-                             trrpt_count_recv, 1, MPI_INTEGER, pright, 0, &
-                             comm2d, status, ierr )
-
-          IF ( number_of_tails+trrpt_count_recv > maximum_number_of_tails ) &
-          THEN
-             IF ( netcdf_data_format < 3 )  THEN
-                message_string = 'maximum_number_of_tails ' //   &
-                                 'needs to be increased ' //     &
-                                 '&but this is not allowed wi'// &
-                                 'th netcdf_data_format < 3'
-                CALL message( 'lpm_exch_horiz', 'PA0147', 2, 2, -1, 6, 1 )
-             ELSE
-                CALL lpm_extend_tail_array( trrpt_count_recv )
-             ENDIF
-          ENDIF
-
-          CALL MPI_SENDRECV( trlpt(1,1,1), trlpt_count*tlength, MPI_REAL,      &
-                             pleft, 1,                                         &
-                             particle_tail_coordinates(1,1,number_of_tails+1), &
-                             trrpt_count_recv*tlength, MPI_REAL, pright, 1,    &
-                             comm2d, status, ierr )
-!
-!--       Update the tail ids for the transferred particles
-          nn = number_of_tails
-          DO  n = number_of_particles+1, number_of_particles+trrp_count_recv
-             IF ( particles(n)%tail_id /= 0 )  THEN
-                nn = nn + 1
-                particles(n)%tail_id = nn
-             ENDIF
-          ENDDO
-
-       ENDIF
-
 !
 !--    Send right boundary, receive left boundary
@@ -503,48 +412,5 @@
        IF ( trlp_count_recv > 0 )  CALL Add_particles_to_gridcell(rvlp(1:trlp_count_recv))
 
-       DEALLOCATE(rvlp)
-
-       IF ( use_particle_tails )  THEN
-
-          CALL MPI_SENDRECV( trrpt_count,      1, MPI_INTEGER, pright, 0, &
-                             trlpt_count_recv, 1, MPI_INTEGER, pleft,  0, &
-                             comm2d, status, ierr )
-
-          IF ( number_of_tails+trlpt_count_recv > maximum_number_of_tails ) &
-          THEN
-             IF ( netcdf_data_format < 3 )  THEN
-                message_string = 'maximum_number_of_tails ' //   &
-                                 'needs to be increased ' //     &
-                                 '&but this is not allowed wi'// &
-                                 'th netcdf_data_format < 3'
-                CALL message( 'lpm_exch_horiz', 'PA0147', 2, 2, -1, 6, 1 ) 
-             ELSE
-                CALL lpm_extend_tail_array( trlpt_count_recv )
-             ENDIF
-          ENDIF
-
-          CALL MPI_SENDRECV( trrpt(1,1,1), trrpt_count*tlength, MPI_REAL,      &
-                             pright, 1,                                        &
-                             particle_tail_coordinates(1,1,number_of_tails+1), &
-                             trlpt_count_recv*tlength, MPI_REAL, pleft, 1,     &
-                             comm2d, status, ierr )
-!
-!--       Update the tail ids for the transferred particles
-          nn = number_of_tails
-          DO  n = number_of_particles+1, number_of_particles+trlp_count_recv
-             IF ( particles(n)%tail_id /= 0 )  THEN
-                nn = nn + 1
-                particles(n)%tail_id = nn
-             ENDIF
-          ENDDO
-
-       ENDIF
-
-!       number_of_particles = number_of_particles + trlp_count_recv
-!       number_of_tails     = number_of_tails     + trlpt_count_recv
-
-       IF ( use_particle_tails )  THEN
-          DEALLOCATE( trlpt, trrpt )
-       ENDIF
+       DEALLOCATE( rvlp )
        DEALLOCATE( trlp, trrp )
 
@@ -589,8 +455,6 @@
                       IF ( j < nys )  THEN
                          trsp_count = trsp_count + 1
-                         IF ( particles(n)%tail_id /= 0 )  trspt_count = trspt_count + 1
                       ELSEIF ( j > nyn )  THEN
                          trnp_count = trnp_count + 1
-                         IF ( particles(n)%tail_id /= 0 )  trnpt_count = trnpt_count + 1
                       ENDIF
                    ENDIF
@@ -609,10 +473,4 @@
        trsp = zero_particle
        trnp = zero_particle
-
-       IF ( use_particle_tails )  THEN
-          ALLOCATE( trspt(maximum_number_of_tailpoints,5,trspt_count), &
-                    trnpt(maximum_number_of_tailpoints,5,trnpt_count) )
-          tlength = maximum_number_of_tailpoints * 5
-       ENDIF
 
        trsp_count  = nr_move_south
@@ -633,6 +491,4 @@
              particles => grid_particles(kp,jp,ip)%particles(1:number_of_particles)
              DO  n = 1, number_of_particles
-
-                nn = particles(n)%tail_id
 !
 !--             Only those particles that have not been marked as 'deleted' may
@@ -655,9 +511,4 @@
                                particles(n)%origin_y = ( ny + 1 ) * dy + &
                                particles(n)%origin_y
-                               IF ( use_particle_tails  .AND.  nn /= 0 )  THEN
-                                  i = particles(n)%tailpoints
-                                  particle_tail_coordinates(1:i,2,nn) =        &
-                                     ( ny+1 ) * dy + particle_tail_coordinates(1:i,2,nn)
-                               ENDIF
                             ELSE
                                trsp_count = trsp_count + 1
@@ -677,13 +528,4 @@
                                ENDIF
 
-                               IF ( use_particle_tails  .AND.  nn /= 0 )  THEN
-                                  trspt_count = trspt_count + 1
-                                  trspt(:,:,trspt_count) = &
-                                  particle_tail_coordinates(:,:,nn)
-                                  trspt(:,2,trspt_count) = ( ny + 1 ) * dy + &
-                                  trspt(:,2,trspt_count)
-                                  tail_mask(nn) = .FALSE.
-                                  deleted_tails = deleted_tails + 1
-                               ENDIF
                             ENDIF
 
@@ -693,8 +535,4 @@
                             particles(n)%particle_mask = .FALSE.
                             deleted_particles = deleted_particles + 1
-                            IF ( use_particle_tails  .AND.  nn /= 0 )  THEN
-                               tail_mask(nn) = .FALSE.
-                               deleted_tails = deleted_tails + 1
-                            ENDIF
 
                          ELSEIF ( ibc_par_ns == 2 )  THEN
@@ -714,10 +552,4 @@
                          deleted_particles = deleted_particles + 1
 
-                         IF ( use_particle_tails  .AND.  nn /= 0 )  THEN
-                            trspt_count = trspt_count + 1
-                            trspt(:,:,trspt_count) = particle_tail_coordinates(:,:,nn)
-                            tail_mask(nn) = .FALSE.
-                            deleted_tails = deleted_tails + 1
-                         ENDIF
                       ENDIF
 
@@ -733,9 +565,4 @@
                                particles(n)%origin_y =                         &
                                   particles(n)%origin_y - ( ny + 1 ) * dy
-                               IF ( use_particle_tails  .AND.  nn /= 0 )  THEN
-                                  i = particles(n)%tailpoints
-                                  particle_tail_coordinates(1:i,2,nn) =        &
-                                     - (ny+1) * dy + particle_tail_coordinates(1:i,2,nn)
-                               ENDIF
                             ELSE
                                trnp_count = trnp_count + 1
@@ -747,13 +574,4 @@
                                particles(n)%particle_mask = .FALSE.
                                deleted_particles = deleted_particles + 1
-                               IF ( use_particle_tails  .AND.  nn /= 0 )  THEN
-                                  trnpt_count = trnpt_count + 1
-                                  trnpt(:,:,trnpt_count) =                     &
-                                     particle_tail_coordinates(:,:,nn)
-                                  trnpt(:,2,trnpt_count) =                     &
-                                     trnpt(:,2,trnpt_count) - ( ny + 1 ) * dy
-                                  tail_mask(nn) = .FALSE.
-                                  deleted_tails = deleted_tails + 1
-                               ENDIF
                             ENDIF
 
@@ -763,8 +581,4 @@
                             particles(n)%particle_mask = .FALSE.
                             deleted_particles = deleted_particles + 1
-                            IF ( use_particle_tails  .AND.  nn /= 0 )  THEN
-                               tail_mask(nn) = .FALSE.
-                               deleted_tails = deleted_tails + 1
-                            ENDIF
 
                          ELSEIF ( ibc_par_ns == 2 )  THEN
@@ -784,10 +598,4 @@
                          deleted_particles = deleted_particles + 1
 
-                         IF ( use_particle_tails  .AND.  nn /= 0 )  THEN
-                            trnpt_count = trnpt_count + 1
-                            trnpt(:,:,trnpt_count) = particle_tail_coordinates(:,:,nn)
-                            tail_mask(nn) = .FALSE.
-                            deleted_tails = deleted_tails + 1
-                         ENDIF
                       ENDIF
 
@@ -819,44 +627,4 @@
        DEALLOCATE(rvnp)
 
-       IF ( use_particle_tails )  THEN
-
-          CALL MPI_SENDRECV( trspt_count,      1, MPI_INTEGER, psouth, 0, &
-                             trnpt_count_recv, 1, MPI_INTEGER, pnorth, 0, &
-                             comm2d, status, ierr )
-
-          IF ( number_of_tails+trnpt_count_recv > maximum_number_of_tails ) &
-          THEN
-             IF ( netcdf_data_format < 3 )  THEN
-                message_string = 'maximum_number_of_tails ' //    &
-                                 'needs to be increased ' //      &
-                                 '&but this is not allowed wi' // &
-                                 'th netcdf_data_format < 3'
-                CALL message( 'lpm_exch_horiz', 'PA0147', 2, 2, -1, 6, 1 ) 
-             ELSE
-                CALL lpm_extend_tail_array( trnpt_count_recv )
-             ENDIF
-          ENDIF
-
-          CALL MPI_SENDRECV( trspt(1,1,1), trspt_count*tlength, MPI_REAL,      &
-                             psouth, 1,                                        &
-                             particle_tail_coordinates(1,1,number_of_tails+1), &
-                             trnpt_count_recv*tlength, MPI_REAL, pnorth, 1,    &
-                             comm2d, status, ierr )
-
-!
-!--       Update the tail ids for the transferred particles
-          nn = number_of_tails
-          DO  n = number_of_particles+1, number_of_particles+trnp_count_recv
-             IF ( particles(n)%tail_id /= 0 )  THEN
-                nn = nn + 1
-                particles(n)%tail_id = nn
-             ENDIF
-          ENDDO
-
-       ENDIF
-
-!       number_of_particles = number_of_particles + trnp_count_recv
-!       number_of_tails     = number_of_tails     + trnpt_count_recv
-
 !
 !--    Send back boundary, receive front boundary
@@ -876,46 +644,6 @@
        DEALLOCATE(rvsp)
 
-       IF ( use_particle_tails )  THEN
-
-          CALL MPI_SENDRECV( trnpt_count,      1, MPI_INTEGER, pnorth, 0, &
-                             trspt_count_recv, 1, MPI_INTEGER, psouth, 0, &
-                             comm2d, status, ierr )
-
-          IF ( number_of_tails+trspt_count_recv > maximum_number_of_tails ) &
-          THEN
-             IF ( netcdf_data_format < 3 )  THEN
-                message_string = 'maximum_number_of_tails ' //   &
-                                 'needs to be increased ' //     &
-                                 '&but this is not allowed wi'// &
-                                 'th NetCDF output switched on'
-                CALL message( 'lpm_exch_horiz', 'PA0147', 2, 2, -1, 6, 1 )
-             ELSE
-                CALL lpm_extend_tail_array( trspt_count_recv )
-             ENDIF
-          ENDIF
-
-          CALL MPI_SENDRECV( trnpt(1,1,1), trnpt_count*tlength, MPI_REAL,      &
-                             pnorth, 1,                                        &
-                             particle_tail_coordinates(1,1,number_of_tails+1), &
-                             trspt_count_recv*tlength, MPI_REAL, psouth, 1,    &
-                             comm2d, status, ierr )
-!
-!--       Update the tail ids for the transferred particles
-          nn = number_of_tails
-          DO  n = number_of_particles+1, number_of_particles+trsp_count_recv
-             IF ( particles(n)%tail_id /= 0 )  THEN
-                nn = nn + 1
-                particles(n)%tail_id = nn
-             ENDIF
-          ENDDO
-
-       ENDIF
-
        number_of_particles = number_of_particles + trsp_count_recv
-       number_of_tails     = number_of_tails     + trspt_count_recv
-
-       IF ( use_particle_tails )  THEN
-          DEALLOCATE( trspt, trnpt )
-       ENDIF
+
        DEALLOCATE( trsp, trnp )
 
@@ -928,6 +656,4 @@
     DO  n = 1, number_of_particles
 
-       nn = particles(n)%tail_id
-
        IF ( particles(n)%x < -0.5_wp * dx )  THEN
 
@@ -936,9 +662,5 @@
 !--          Cyclic boundary. Relevant coordinate has to be changed.
              particles(n)%x = ( nx + 1 ) * dx + particles(n)%x
-             IF ( use_particle_tails  .AND.  nn /= 0 )  THEN
-                i = particles(n)%tailpoints
-                particle_tail_coordinates(1:i,1,nn) = ( nx + 1 ) * dx + &
-                                             particle_tail_coordinates(1:i,1,nn)
-             ENDIF
+
           ELSEIF ( ibc_par_lr == 1 )  THEN
 !
@@ -946,8 +668,5 @@
              particles(n)%particle_mask = .FALSE.
              deleted_particles = deleted_particles + 1
-             IF ( use_particle_tails  .AND.  nn /= 0 )  THEN
-                tail_mask(nn) = .FALSE.
-                deleted_tails = deleted_tails + 1
-             ENDIF
+
           ELSEIF ( ibc_par_lr == 2 )  THEN
 !
@@ -963,9 +682,5 @@
 !--          Cyclic boundary. Relevant coordinate has to be changed.
              particles(n)%x = particles(n)%x - ( nx + 1 ) * dx
-             IF ( use_particle_tails  .AND.  nn /= 0 )  THEN
-                i = particles(n)%tailpoints
-                particle_tail_coordinates(1:i,1,nn) = - ( nx + 1 ) * dx + &
-                                             particle_tail_coordinates(1:i,1,nn)
-             ENDIF
+
           ELSEIF ( ibc_par_lr == 1 )  THEN
 !
@@ -973,8 +688,5 @@
              particles(n)%particle_mask = .FALSE.
              deleted_particles = deleted_particles + 1
-             IF ( use_particle_tails  .AND.  nn /= 0 )  THEN
-                tail_mask(nn) = .FALSE.
-                deleted_tails = deleted_tails + 1
-             ENDIF
+
           ELSEIF ( ibc_par_lr == 2 )  THEN
 !
@@ -992,9 +704,5 @@
 !--          Cyclic boundary. Relevant coordinate has to be changed.
              particles(n)%y = ( ny + 1 ) * dy + particles(n)%y
-             IF ( use_particle_tails  .AND.  nn /= 0 )  THEN
-                i = particles(n)%tailpoints
-                particle_tail_coordinates(1:i,2,nn) = ( ny + 1 ) * dy + &
-                                             particle_tail_coordinates(1:i,2,nn)
-             ENDIF
+
           ELSEIF ( ibc_par_ns == 1 )  THEN
 !
@@ -1002,8 +710,5 @@
              particles(n)%particle_mask = .FALSE.
              deleted_particles = deleted_particles + 1
-             IF ( use_particle_tails  .AND.  nn /= 0 )  THEN
-                tail_mask(nn) = .FALSE.
-                deleted_tails = deleted_tails + 1
-             ENDIF
+
           ELSEIF ( ibc_par_ns == 2 )  THEN
 !
@@ -1019,9 +724,5 @@
 !--          Cyclic boundary. Relevant coordinate has to be changed.
              particles(n)%y = particles(n)%y - ( ny + 1 ) * dy
-             IF ( use_particle_tails  .AND.  nn /= 0 )  THEN
-                i = particles(n)%tailpoints
-                particle_tail_coordinates(1:i,2,nn) = - ( ny + 1 ) * dy + &
-                                             particle_tail_coordinates(1:i,2,nn)
-             ENDIF
+
           ELSEIF ( ibc_par_ns == 1 )  THEN
 !
@@ -1029,8 +730,5 @@
              particles(n)%particle_mask = .FALSE.
              deleted_particles = deleted_particles + 1
-             IF ( use_particle_tails  .AND.  nn /= 0 )  THEN
-                tail_mask(nn) = .FALSE.
-                deleted_tails = deleted_tails + 1
-             ENDIF
+
           ELSEIF ( ibc_par_ns == 2 )  THEN
 !
@@ -1287,5 +985,5 @@
     INTEGER(iwp), INTENT(in)                       ::  j              !<
     INTEGER(iwp), INTENT(in)                       ::  k              !<
-    INTEGER(iwp), INTENT(in), optional             ::  size_in        !<
+    INTEGER(iwp), INTENT(in), OPTIONAL             ::  size_in        !<
 
     INTEGER(iwp)                                   :: old_size        !<
@@ -1300,5 +998,5 @@
        new_size = size_in
     ELSE
-       new_size = old_size * ( 1.0 + alloc_factor / 100.0 )
+       new_size = old_size * ( 1.0_wp + alloc_factor / 100.0_wp )
     ENDIF
 
